var canvas,
    context,
    
    width = 1280,
    height = 720,

    debug = false,
    
    images = {
        'dude-still': loadImage('dude-still.gif'),
        'dude-walk': loadImage('dude-walk.gif'),
        'dude-blink': loadImage('dude-blink.gif'),
        'dude-talk': loadImage('dude-talk.gif'),
        'floorwall': loadImage('floorwall.png'),
        'fridge': loadImage('fridge.png'),
        'sofa': loadImage('sofa.png'),
        'tv': loadImage('tv.png'),
        'door': loadImage('door.png'),
        'trashcan': loadImage('trashcan.png'),
        'table': loadImage('table.png'),
        'rightchair': loadImage('rightchair.png'),
        'leftchair': loadImage('leftchair.png'),
        'lamp': loadImage('lamp.png'),
        'guest-1-still': loadImage('guest-1-still.gif'),
        'guest-1-walk': loadImage('guest-1-walk.gif'),
        'guest-1-blink': loadImage('guest-1-blink.gif'),
        'guest-1-talk': loadImage('guest-1-talk.gif'),
        'guest-2-still': loadImage('guest-2-still.gif'),
        'guest-2-walk': loadImage('guest-2-walk.gif'),
        'guest-2-blink': loadImage('guest-2-still.gif'),
        'guest-2-talk': loadImage('guest-2-talk.gif'),
        'guest-3-still': loadImage('guest-3-still.gif'),
        'guest-3-walk': loadImage('guest-3-walk.gif'),
        'guest-3-blink': loadImage('guest-3-blink.gif'),
        'guest-3-talk': loadImage('guest-3-talk.gif'),
        'guest-4-still': loadImage('guest-4-still.gif'),
        'guest-4-walk': loadImage('guest-4-walk.gif'),
        'guest-4-blink': loadImage('guest-4-still.gif'),
        'guest-4-talk': loadImage('guest-4-talk.gif'),
        'hotdog': loadImage('hotdog.gif'),
        'soda': loadImage('soda.gif'),
        'trash': loadImage('trash.gif'),
    },
    flipped = {},

    player = new Human({
        'name': 'dude',
        'x': 520,
        'y': 220,
        'destX': 520,
        'destY': 380,
        'guest': false,
        'speed': 2,
        'destCallback': function () {
            player.text = [
                ['It\'s almost 8...', 300],
                ['My guests should be here any moment.', 400],
            ];
        },
    }),

    door = {
        'static': 'door',
        'x': 390,
        'y': 0,
        'height': 345,
        'action': function () {
            movePlayerTo(450, 50, true);
        }
    },
    
    entities = [
        player,
        {
            'static': 'floorwall',
            'x': 0,
            'y': 0,
            'height': 0,
        },
        {
            'static': 'fridge',
            'x': 28,
            'y': 58,
            'height': 350,
            'action': function () {
                movePlayerTo(220, 140, false, function () {
                    sound('blip');
                    setTimeout(function () {
                        if (!player.holding) {
                            player.holding = 'hotdog';
                        }
                        else if (player.holding == 'hotdog') {
                            player.holding = 'soda';
                        }
                        else if (player.holding == 'soda') {
                            player.holding = undefined;
                        }
                    }, 200);
                });
            }
        },
        door,
        {
            'static': 'lamp',
            'x': 614,
            'y': 0,
            'height': 0,
        },
        {
            'static': 'tv',
            'x': 932,
            'y': 114,
            'height': 220,
            'action': function () {
                movePlayerTo(1030, 150, true, function () {
                    sound('blip');
                    setTimeout(function () {appease('tv')}, 500);
                });
            }
        },
        {
            'static': 'sofa',
            'x': 530,
            'y': 295,
            'height': 170,
            'action': function () {
                movePlayerTo(600, 225);
            }
        },
        {
            'static': 'trashcan',
            'x': 0,
            'y': 458,
            'height': 220,
            'action': function () {
                movePlayerTo(65, 350, undefined, function () {
                    if (trashGuest) {
                        sound('blip');
                        player.holding = undefined;
                        trashGuest.need = undefined;
                        trashGuest.text = [
                            [
                                [
                                    'Oh... Thanks.',
                                    'Thanks man.',
                                    'Ah, much better!',
                                    'Cheers!',
                                    'Nice!',
                                    'Cool.',
                                ][Math.round(Math.random() * 5)],
                                300
                            ],
                        ];
                        trashGuest = undefined;
                    }
                });
            }
        },
        {
            'static': 'leftchair',
            'x': 331,
            'y': 362,
            'height': 200,
            'action': function () {
                movePlayerTo(400, 330, true);
            }
        },
        {
            'static': 'table',
            'x': 593,
            'y': 440,
            'height': 150,
            'action': function () {
                movePlayerTo(710, 330);
            }
        },
        {
            'static': 'rightchair',
            'x': 996,
            'y': 380,
            'height': 210,
            'action': function () {
                movePlayerTo(980, 320, false);
            }
        },
    ],
    
    lastGuestTime = (new Date()).getTime() - 50000,
    guestDelay = 60 * 1000,
    guestCount = 0,
    guests = [],

    lastNeedTime = lastGuestTime,
    needDelay = (5 + Math.random() * 10) * 1000,

    locations = [
        //[220, 140, false],
        //[450, 50, true],
        //[1030, 150, true],
        //[600, 225],
        //[65, 350, false],
        //[710, 330],

        [810, 220, 1], // Sofa Right
        [600, 220, 1], // Sofa Left
        [110, 400, 1], // By Trash
        [630, 120, 0], // Behind Sofa
        //[050, 160, 1], // By Fridge
        [650, 350, 1], // By Table
        [980, 320, 0], // Right Chair
        [400, 330, 1], // Left Chair
        [880, 130, 1], // Staring TV
    ],
    
    gameStartTime = (new Date()).getTime(),
    
    doorShouldBeUp = false,
    doorCallback = undefined,
    
    trashGuest;


window.addEventListener('load', function () {
    canvas = document.getElementById('canvas');
    context = canvas.getContext('2d');

    /*canvas.addEventListener('mousemove', function (event) {
        player.x = event.offsetX;
        player.y = event.offsetY;
    });*/

    canvas.addEventListener('mousedown', function (event) {
        var mx = event.pageX - event.target.offsetLeft,
            my = event.pageY - event.target.offsetTop,
            ex,
            ey,
            i,
            entity;
        
        console.log('x: ' + mx + ' y: ' + (my - 306));
        
        // Order things
        entities.sort(function(a, b) {return (a.y + a.height) - (b.y + b.height)});

        for (i = entities.length - 1; i >= 0; i --) {
            entity = entities[i];
            ex = entity.x;
            ey = entity.y;

            if (mx > ex && mx < ex + entity.width && my > ey && my < ey + entity.height) {
                console.log(entity.static);
                if (entity.action) {
                    entity.action();
                }
                else if (entity.guest && (player.holding || entity.need == 'trash')) {
                    movePlayerTo(entity.x + 30, entity.y + 30, false, function () {
                        if (player.holding) {
                            if (entity.need == player.holding) {
                                sound('blip');
                                player.holding = undefined;
                                entity.need = undefined;
                                entity.text = [
                                    [
                                        [
                                            'Oh... Thanks.',
                                            'Thanks man.',
                                            'Ah, much better!',
                                            'Cheers!',
                                            'Nice!',
                                            'Cool.',
                                        ][Math.round(Math.random() * 5)],
                                        300
                                    ],
                                ];
                            }
                            else {
                                entity.text = [['I don\'t want that!', 200]];
                            }
                        }
                        else if (entity.need == 'trash') {
                            trashGuest = entity;
                            player.holding = 'trash';
                        }
                    });
                }
                break;
            }
        }
    });

    loop();
});

function loadImage(source) {
    var image = new Image();

    image.src = 'images/' + source;

    return image;
}

function loop() {
    var time = (new Date()).getTime(),
        guest,

        gameHours,
        gameMinutes,
        pm;

    if (doorShouldBeUp && door.y > - 300) {
        door.y -= 2;
    }
    else if (!doorShouldBeUp && door.y < 0) {
        door.y += 2;
    }
    else if (doorCallback) {
        doorCallback();
        doorCallback = undefined;
    }
    // This is so hacky.. Keeps door in front of new guest.
    door.height = 345 - door.y;

    if (guestCount < 5 && time > lastGuestTime + guestDelay) {
        guest = new Human();

        entities.push(guest);
        guests.push(guest);

        guestDelay = (1+Math.random()*2) * 30 * 1000;

        lastGuestTime = time;
        guestCount = guests.length;

        doorCallback = function () {
            guest.active = true;
            guest.text = [
                [
                    [
                        'The party is here!',
                        'Ooooh, nice place!',
                        'Alright! Just in time!',
                        'Yeee haw!',
                        'Hello hello!',
                    ][Math.round(Math.random()*4)],
                    300
                ]
            ]
            setTimeout(function () {
                doorCallback = function () {
                    sound('close');
                };
                doorShouldBeUp = false;
            }, 500);
        };
        doorShouldBeUp = true;
        sound('door');
    }

    // If no guests, no needs
    if (!guestCount) {
        lastNeedTime = time;
    }

    if (time > lastNeedTime + needDelay) {
        guest = guests[Math.floor(Math.random() * guestCount)];

        if (guest) {
            guest.beNeedy();
        }

        needDelay = (Math.random() * 10) * 1000;

        lastNeedTime = time;
    }

    // Order things
    entities.sort(function(a, b) {return (a.y + a.height) - (b.y + b.height)});

    entities.forEach(function (entity) {
        var imageName,
            image;

        if (entity.move) {
            entity.move();
        }

        if (entity.guest) {
            entity.party();
        }

        if (entity.static) {
            imageName = entity.static;
            image = images[imageName];
            context.drawImage(image, entity.x, entity.y);
            if (!entity.width) {
                entity.width = image.width;
            }
        }
        else {
            entity.draw();
        }

        // For Z box thing testing
        /*context.fillStyle = 'rgba(255, 0, 0, .3)';
        context.fillRect(entity.x, entity.y, entity.width, entity.height);*/

    });

    gameMinutes = Math.floor((time - gameStartTime) / 1000) + 1195;
    gameHours = Math.floor(gameMinutes / 60);
    gameMinutes = gameMinutes - (gameHours * 60);

    gameHours = gameHours % 24;

    if (gameHours >= 12) {
        pm = true;
    }
    else {
        pm = false;
    }

    // I'm sure there is a better way...
    if (gameHours > 12) {
        gameHours -= 12;
    }
    if (gameHours == 0) {
        gameHours = 12;
    }

    if (gameMinutes < 10) {
        gameMinutes = '0' + gameMinutes;
    }

    context.font = '30px Verdana';
    context.textAlign = 'center';

    context.shadowColor = 'black';
    context.shadowBlur = 10;

    context.fillStyle = 'white';
    if (pm) {
        context.fillText(gameHours+':'+gameMinutes+' pm', 1280 - 100, 50);
    }
    else {
        context.fillText(gameHours+':'+gameMinutes+' am', 1280 - 100, 50);
    }

    context.shadowBlur = 0;

    setTimeout(loop, 10);
}

function movePlayerTo(x, y, right, callback) {
    player.destX = x;
    player.destY = y;
    player.destRight = right;
    player.destCallback = callback;
}

function flipImage(name) {
    var image,
        flipCanvas,
        flipContext,
        flippedImage;

    if (flipped[name]) {
        return flipped[name];
    }

    image = images[name];

    flipCanvas = document.createElement('canvas');
    flipCanvas.width = image.width;
    flipCanvas.height = image.height;

    flipContext = flipCanvas.getContext('2d');

    flipContext.translate(image.width, 0);
    flipContext.scale(-1, 1);
    flipContext.drawImage(image, 0, 0);

    flippedImage = new Image();
    flippedImage.src = flipCanvas.toDataURL();

    flipped[name] = flippedImage;

    return flippedImage;
}

function Human(options) {
    var self = this,
        i,
        ii,
        r,
        
        pause = 0,
        destination = [];

    if (!options) {
        options = {};
    }

    if (!options.name) {
        name = 'guest-' + (Math.floor(Math.random()*4) + 1);
    }
    else {
        name = options.name;
    }

    self.speed = 1;

    self.x = 400;
    self.y = 30;
    self.destX = 400;
    self.destY = 30;
    self.destRight = undefined;
    self.destCallback = undefined;

    // Generate an idle animation
    self.idle = [];
    for (i = 0; i < 5; i ++) {
        r = Math.floor(Math.random() * 20) + 10;
        for (ii = 0; ii < r; ii ++) {
            self.idle.push(name + '-still');
        }
        self.idle.push(name + '-blink');
    }

    self.walk = [];
    for (i = 0; i < 2; i ++) {
        self.walk.push(name + '-still');
    }
    for (i = 0; i < 2; i ++) {
        self.walk.push(name + '-walk');
    }

    self.talk = [];
    for (i = 0; i < 5; i ++) {
        r = Math.floor(Math.random() * 2) + 1;
        for (ii = 0; ii < r; ii ++) {
            self.talk.push(name + '-still');
        }
        for (ii = 0; ii < r; ii ++) {
            self.talk.push(name + '-talk');
        }
    }

    self.walktalk = [];
    for (i = 0; i < 5; i ++) {
        r = Math.round(Math.random()) + 1;
        for (ii = 0; ii < r; ii ++) {
            self.walktalk.push(name + '-talk');
        }
        for (ii = 0; ii < 2-r; ii ++) {
            self.walktalk.push(name + '-still');
        }
        for (ii = 0; ii < 2; ii ++) {
            self.walktalk.push(name + '-walk');
        }
    }

    self.height = 306;
    self.animation = 'idle';
    self.frame = 10;
    self.right = false;
    self.guest = true;

    self.need = undefined;
    self.text = [];
    self.patience = 100;
    self.fullPatience = 100;
    self.active = false;
    self.holding = undefined;

    self.move = function () {
        var moveAmount = self.speed,
            roundedPX = Math.round(self.x/moveAmount),
            roundedPY = Math.round(self.y/moveAmount),
            roundedGX = Math.round(self.destX/moveAmount),
            roundedGY = Math.round(self.destY/moveAmount),
            text = self.text[0];

        /*self.x = self.destX;
        self.y = self.destY;*/

        if (roundedPX != roundedGX || roundedPY != roundedGY) {
            if (text) {
                self.animation = 'walktalk';
            }
            else {
                self.animation = 'walk';
            }

            if (roundedGX > roundedPX) {
                self.right = true;
                self.x += moveAmount;
            }
            else if (roundedGX < roundedPX) {
                self.right = false;
                self.x -= moveAmount;
            }

            if (roundedGY > roundedPY) {
                self.y += moveAmount;
            }
            else if (roundedGY < roundedPY) {
                self.y -= moveAmount;
            }
        }
        else {
            if (typeof self.destRight !== 'undefined') {
                self.right = self.destRight;
            }
            if (self.animation == 'walk') {
                self.animation = 'idle';
            }
            if (self.destCallback) {
                self.destCallback();
                self.destCallback = undefined;
            }
        }
    };

    self.party = function () {
        if (pause < 1 && self.active) {
            destination[3] = false;

            while (true) {
                destination = locations[Math.floor(Math.random() * locations.length)];

                if (!destination[3]) {
                    break;
                }
                else {
                    console.log('taken!');
                }
            }

            destination[3] = true;
            self.destX = destination[0];
            self.destY = destination[1];
            self.destRight = destination[2];

            /*self.destX = Math.floor(Math.random() * (1280 - 100));
            self.destY = Math.floor(Math.random() * (720 - 400)) + 100;
            self.destRight = Math.round(Math.random());*/

            console.log([self.destX, self.destY, self.destRight]);

            pause = Math.floor(Math.random() * 6000) + 1000;
        }
        else {
            pause --;
        }

        if (self.need) {
            self.patience --;
        }

        if (self.need && self.patience < 1) {
            self.text = [
                [
                    [
                        'This party sucks.',
                        'I thought this was gonna be fun.',
                        'I\'m outta here.',
                        'Uhh, I gotta go.',
                        'Hmph, see ya later.',
                    ][Math.round(Math.random() * 4)],
                    200
                ]
            ];
            self.need = undefined;

            // AHHHHHH!
            destination[3] = false;

            self.active = false;

            doorShouldBeUp = true;
            sound('door');
            self.destX = 400;
            self.destY = 30;
            self.destCallback = function () {
                doorCallback = function () {
                    var i,
                        l = guests.length;

                    sound('close');

                    for (i = 0; i < l; i ++) {
                        if (guests[i] == self) {
                            guests.splice(i, 1);
                            console.log('removed guest');
                            break;
                        }
                    }
                    guestCount = guests.length;

                    l = entities.length;
                    for (i = 0; i < l; i ++) {
                        if (entities[i] == self) {
                            entities.splice(i, 1);
                            console.log('removed entity');
                            break;
                        }
                    }

                    if (guestCount == 0) {
                        lastGuestTime = (new Date()).getTime()*2;
                        player.text = [
                            ['Well. I guess that\'s over.', 300],
                            ['Game Over', 99999]
                        ];
                        setTimeout(function () {
                            sound('gameover');
                        }, 2000);

                    }
                };
                doorShouldBeUp = false;
            };
        }
    };

    self.beNeedy = function () {
        var r = Math.round(Math.random() * 3);

        if (!self.need && self.active && self.animation == 'idle') {
            switch (r) {
                case 0:
                    self.need = 'tv';
                    self.text = [
                        [
                            [
                                'Uggg, I hate this show.',
                                'Can we watch something else?',
                                'What else is on TV?',
                                'Why are we watching this?',
                                'You like this show?',
                            ][Math.round(Math.random() * 4)],
                            300
                        ]
                    ];
                    break;
                case 1:
                    self.need = 'hotdog';
                    self.text = [
                        [
                            [
                                'Ooh, do I smell hotdogs?',
                                'I\'m hungry!',
                                'Got anything to eat?',
                                'Where\'s the food?',
                                'Hotdog please!',
                            ][Math.round(Math.random() * 4)],
                            300
                        ]
                    ];
                    break;
                case 2:
                    self.need = 'soda';
                    self.text = [
                        [
                            [
                                'You got anything to drink?',
                                'I\'m thirsty!',
                                'Do you have soda?',
                            ][Math.round(Math.random() * 2)],
                            300
                        ]
                    ];
                    break;
                case 3:
                    self.need = 'trash';
                    self.text = [
                        [
                            [
                                'Can you throw this out?',
                                'I\'ve got some trash.',
                                'Where do I put this?',
                            ][Math.round(Math.random() * 2)],
                            300
                        ]
                    ];
                    break;
            }

            self.patience = self.fullPatience = Math.floor(Math.random() * 500) + 1000;
        }
    };

    self.draw = function () {
        var frames = self[self.animation];
            imageName = frames[Math.floor(self.frame / 20)% frames.length];
            image = images[imageName],
            text = self.text[0],
            offset = 10;

        if (!self.width) {
            self.width = image.width;
        }

        self.frame ++;

        if (self.right) {
            context.drawImage(flipImage(imageName), self.x, self.y);
        }
        else {
            context.drawImage(image, self.x, self.y);
        }

        if (self.holding) {
            if (self.right) {
                context.drawImage(flipImage(self.holding), self.x + 7, self.y + 142);
            }
            else {
                context.drawImage(images[self.holding], self.x + 68, self.y + 142);
            }
        }

        if (text) {
            self.animation = 'talk';

            context.font = '30px Verdana';
            context.textAlign = 'center';

            context.shadowColor = 'black';
            context.shadowBlur = 10;

            context.fillStyle = 'white';
            if (self.need) {
                offset += 15;
            }
            context.fillText(text[0], self.x + self.width/2, self.y - offset);

            context.shadowBlur = 0;

            text[1] --;

            if (!text[1]) {
                self.text.shift();
            }
        }
        else {
            if (self.animation == 'talk') {
                self.animation = 'idle';
            }
        }

        if (self.need && self.patience > 0) {
            context.fillStyle = 'gray';
            context.fillRect(self.x + Math.floor(image.width-100) / 2, self.y - 15, 100, 10);

            context.fillStyle = 'white';
            context.fillRect(self.x + Math.floor(image.width-100) / 2, self.y - 15, Math.floor((self.patience / self.fullPatience) * 100), 10);
        }
    };

    extend(self, options);
}

function extend(destination, source) {
    for (key in source) {
        destination[key] = source[key];
    }
}

function appease(need) {
    guests.forEach(function (guest) {
        if (guest.need == need) {
            guest.need = undefined;
            guest.text = [
                [
                    [
                        'Oh... Thanks.',
                        'Thanks man.',
                        'Ah, much better!',
                        'Cheers!',
                        'Nice!',
                        'Cool.',
                    ][Math.round(Math.random() * 5)],
                    300
                ],
            ];
        }
    });
}

function sound(name) {
    var audio = new Audio('sounds/' + name + '.wav');
    audio.play();
}
